/****************************************************************************/
/*           YOUR SYSTEM CONFIGURATION!!!                                   */
/* Edit these values to your particular system, then recompile all programs */
/* which use Citadel.h, so they all use your new values. Customize your   */
/* system BEFORE running setup for the first time to avoid UNIXmadness!!    */
/****************************************************************************/

/****************************************************************************/
/* Networking stuff
 * set NODENAME to your UUCP node name. Set PREVMSGS to the number of
 * records you want in the prevmsgs file, which keeps a record of recently
 * seen messages on all systems. This prevents messages from cycling
 * endlessly through the network. If you are not in a network, set PREVMSGS
 * to 2. If messages seem to be cycling endlessly through the network,
 * increase the value of PREVMSGS.
 */

#define NODENAME	"cavevax"	/* Your system's uucp nodename      */
#define PREVMSGS	2		/* Number of recs in prevmsgs file  */
/****************************************************************************/

#define BBSUID		999
/* make an account called "bbs", "guest", or something to that effect which
 * shells directly to citadel. Place the userid of the account here. */

#define CREATAIDE	0
/* If CREATAIDE is set to 1, anyone who creates a class 3 (passworded) or
 * class 4 (invitation-only) room automatically becomes the room-aide for
 * that room. */

#define SLEEPING	1800
/* If the program is waiting for input more than SLEEPING number of seconds,
 * Citadel will print "Sleeping? Call again." and hang up. To disable the
 * feature, set SLEEPING to 0. */

/* You may NOT change these six values once you set up your system.	    */
#define MAXROOMS	100		/* Number of rooms in system        */
#define NVOTES		10		/* Number of votes sys can handle   */
#define MAILSLOTS	35		/* Number of mail slots             */
#define MSGSPERRM	150		/* Messages per room                */
#define MM_FILELEN	(2000000L)	/* Number of bytes in message file  */
#define CALLLOG		1000		/* Number of entries in call log    */
/* Do not set MAILSLOTS higher than MSGSPERRM 				    */

/* problem user stuff. */
#define IAADETECT	1		/* 1=on, 0=off                      */
#define IAAROOM		"IAA etc."	/* Name of room to send problems to */
