/*
 * Citadel/UX setup program
 * v1.1 / by Art Cancro 05/25/89
 * see copyright.doc for copyright information
 *
 * *** YOU MUST EDIT sysconfig.h >BEFORE< COMPILING SETUP ***
 */

#include <stdio.h>
#include <ctype.h>
#include <fcntl.h>
#include "citadel.h"

main() {
	int a;
	char aaa[20];
	printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
	printf("Citadel/UX setup program\n\n");
	printf("DO NOT re-create files that you wish to keep intact.\n");
	printf("They will be ERASED if you do so!\n");
	printf("If you are setting up Citadel/UX for the first time,\n");
	printf("answer 'yes' to all of the prompts.\n\n");

	a=0;	
	printf("\nCreate message file? ");
	gets(aaa);
	aaa[0]=tolower(aaa[0]);
	a=aaa[0];
	if (aaa[0]=='y') cre8msg();

	printf("\n   Create user file? ");
	gets(aaa);
	aaa[0]=tolower(aaa[0]);
	if (aaa[0]=='y') cre8user();

	printf("\n  Create room files? ");
	if (a!='y') gets(aaa);
	aaa[0]=tolower(aaa[0]);
	if (aaa[0]=='y') cre8room();

	printf("\n    Create call log? ");
	gets(aaa);
	aaa[0]=tolower(aaa[0]);
	if (aaa[0]=='y') cre8clog();

	printf("\nSetup finished.\n");
	exit(0);
}

cre8msg() {
	struct msgmain msgmain;
	FILE *fp;
	long aa;

	fp=fopen("msgmain","wb");
	for (aa=0; aa<=(MM_FILELEN+100); ++aa) {
		putc(0,fp);
		if ((aa%10000L)==0L)
			printf("setup: writing msgmain byte %15ld\r",aa);
		}
	fclose(fp);

	printf("setup: writing control structure and unlocking file\n");
	msgmain.MMlowest=1L;
	msgmain.MMhighest=1L;
	msgmain.MMcurpos=0L;
	msgmain.MMflags=0;

	fp=fopen("MMstructure","wb");
	fwrite(&msgmain,sizeof(struct msgmain),1,fp);
	fclose(fp);
}

cre8user() {
	int file;
	struct usersupp usersupp;
	long aa;

	printf("setup: creating a blank user file\n");
	unlink("usersupp");
	file=creat("usersupp",0666);
	usersupp.screenwidth=0;
	usersupp.eternal=0L;
	usersupp.timescalled=0;
	usersupp.posted=0;
	usersupp.flags=US_UNLISTED;
	usersupp.USuid=(-1);
	strcpy(usersupp.fullname,"!");
	strcpy(usersupp.password,"");
	usersupp.axlevel=4;
	write(file,&usersupp,sizeof(struct usersupp));
	close(file);
	file=creat("eternal",0666);
	chmod("eternal",0666);
	aa=1L;
	write(file,&aa,4);
	close(file);
}

cre8room() {
	int a;
	FILE *fp;
	char aaa[50];
	struct quickroom quickroom;
	struct fullroom fullroom;

	printf("setup: creating and initializing room files\n");

	/* Load up a blank fullroom structure to be used for all rooms */
	for (a=0; a<MSGSPERRM; ++a) {
		fullroom.FRnum[a]=0L;
		fullroom.FRpos[a]=0L;
		}

	/* Open a new quickroom file */
	fp=fopen("quickroom","wb");
	strcpy(quickroom.QRpasswd,"");
	quickroom.QRroomaide=0L;
	quickroom.QRhighest=0L;
	quickroom.QRgen=1;
	quickroom.QRflags=QR_INUSE;

	/* Create Lobby> Mail> and Aide> */
	strcpy(quickroom.QRname,"Lobby");
	fwrite(&quickroom,sizeof(struct quickroom),1,fp);

	strcpy(quickroom.QRname,"Mail");
	fwrite(&quickroom,sizeof(struct quickroom),1,fp);
	
	strcpy(quickroom.QRname,"Aide");
	fwrite(&quickroom,sizeof(struct quickroom),1,fp);

	/* make the remaining rooms blanks */
	strcpy(quickroom.QRname,"");
	quickroom.QRflags=0;
	for (a=3; a<MAXROOMS; ++a) {
		printf("setup: creating quickroom %-3d\r",a);
		fwrite(&quickroom,sizeof(struct quickroom),1,fp);
		}
	fclose(fp);

	/* Create directories and fullroom files */
	system("mkdir rooms");
	for (a=0; a<MAXROOMS; ++a) {
		printf("setup: creating fullroom %-4d\n",a);
		sprintf(aaa,"./rooms/fullrm%d",a);
		fp=fopen(aaa,"wb");
		fwrite(&fullroom,sizeof(struct fullroom),1,fp);
		fclose(fp);
		}
}

cre8clog() {
	int file,a;
	struct calllog calllog;

	calllog.CLfullname[0]=0;
	calllog.CLtime=0L;
	calllog.CLflags=0;
	a=0;

	file=creat("calllog.pos",0666);
	chmod("calllog.pos",0666);
	write(file,&a,2);
	close(file);

	file=creat("calllog",0666);
	chmod("calllog",0666);
	for (a=0; a<CALLLOG; ++a) {
		printf("setup: creating call log #%-4d\r",a);
		write(file,&calllog,sizeof(struct calllog));
		}
	close(file);
	return(0);
}
