/*
	Citadel/UX uucp mail reciever
	Version 2.10, January 1989

This is just a quick hack I threw together to enable BBS users
to recieve mail through the uucp mail facility. Move rmail to rmail.real
and compile this program as rmail.
   
  New change: mail can now be recieved by user number, i.e. sysname!cit123
  
  This program looks at the recipient to determine if he/she is a bbs user. It
falls back on the old mailer if:
  
  1. The program is called with less or more than one argument
  2. The recipient is not someone in the BBS user file
     (so users who are in /etc/passwd can still recieve mail)
  3. The recipient name contains ! or @ characters
     (so it doesn't try to mail something that really should be sent
     out of the system via uucp)

 Generally, this program will require a bit of hacking before it will run
on your system. If you have any questions, call UNCENSORED! BBS at
(914) 761-6877. Good luck...

*/
  
#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include "/usr/bbs/citadel.h"

long lseek();
long atol();

long finduser(file,name)
int file;
char name[];
{
	struct usersupp temp;
	int a;
	long bottom,top,guess,obottom,otop;

	obottom=(-1L); otop=(-1L);

	bottom=0L;
	top=(lseek(file,0L,2)/(long)sizeof(struct usersupp));

FPT:	if ((obottom==bottom)&&(otop==top)) {
		return(-1L); }
	obottom=bottom; otop=top;
	guess=(((top-bottom)/2)+bottom);
	lseek(file,(guess*(long)sizeof(struct usersupp)),0);
	read(file,&temp,sizeof(struct usersupp));
	a=strucmp(temp.fullname,name);
	if (a==0)
		
		return(lseek(file,(guess*(long)sizeof(struct usersupp)),0));
	if (a<0) {
		bottom=guess;
		goto FPT; }
	if (a>0) {
		top=guess;
		goto FPT; }
}
send_message(filename,retbuf)	/* send a message to the master file */
char filename[];		/* tempfilename of proper message */
struct smreturn *retbuf;	/* return information */
{

int file,a,b,c,d,e,file2;
long aa,bb,cc,dd,ee,templen,hibytes,origpos;
char aaa[100];
struct msgmain msgmain;


	file=open("/usr/bbs/MMstructure",O_RDWR);
	if (file<0) exit(13);
PWMINS:
	a=read(file,&msgmain,sizeof(struct msgmain));
	if (a<1) exit(14);
	if (msgmain.MMflags & MM_BUSY) {
					 lseek(file,0L,0); goto PWMINS; }

	lseek(file,0L,0);
	msgmain.MMflags=(msgmain.MMflags|MM_BUSY);
	a=write(file,&msgmain,sizeof(struct msgmain)); if (a<1) exit(16);
	close(file);
	origpos=msgmain.MMcurpos;

/* measure the message */
file=open(filename,O_RDONLY); if (file<0) exit(17);
templen=lseek(file,0L,2);
close(file);

/* check for FF bytes */
hibytes=0L;
file=open("/usr/bbs/msgmain",O_RDWR);
if (file<0) exit(18);
bb=lseek(file,msgmain.MMcurpos,0);

cc=lseek(file,0L,1);
for (bb=0L; bb<templen; ++bb) {
	if (cc>=MM_FILELEN) cc=lseek(file,0L,0);
	c=0; read(file,&c,1); ++cc;
	if (c>127) ++hibytes;		/* bump count if hi bit set */
	}

msgmain.MMlowest=msgmain.MMlowest+hibytes;
++msgmain.MMhighest;

cc=lseek(file,msgmain.MMcurpos,0);

file2=open(filename,O_RDONLY); if (file2<0) exit(19);
cc=lseek(file,0L,1);
for (bb=0L; bb<templen; ++bb) {
	if (((long)cc)>=((long)MM_FILELEN)) cc=lseek(file,0L,0);
	read(file2,&b,1); 
	write(file,&b,1); ++cc;
	}
msgmain.MMcurpos=lseek(file,0L,1);
close(file2);	/* done with temp file */
close(file);	/* done with master file */


/* now update the message structure */

msgmain.MMflags=msgmain.MMflags & ~MM_BUSY;

file=open("/usr/bbs/MMstructure",O_RDWR); if (file<0) exit(20);
a=write(file,&msgmain,sizeof(struct msgmain)); if (a<1) exit(21);
close(file);

retbuf->smnumber=msgmain.MMhighest;
retbuf->smpos=origpos;



return(0);

}

make_message(filename,recipient)
char filename[];	/* temporary file name */
char recipient[];	/* NULL if it's not mail */
{ 
	char author[300];
	FILE *fp;
	int a,b,c,old;
	long aa,bb,cc,beg,now;
	char aaa[300],bbb[300];

	strcpy(author,"UUCP Mailer");
	strcpy(aaa,"");
	gets(aaa);
	if (strncmp(aaa,"From ",5)) goto NOFRM;
	strcpy(aaa,&aaa[5]);
	strcpy(bbb,"somewhere");
	for (a=0; a<strlen(aaa); ++a)
		if (!strncmp(&aaa[a],"remote from ",12)) {
			strcpy(bbb,&aaa[a+12]);
			aaa[a]=0;
			}
	for (a=0; a<strlen(aaa); ++a) if (aaa[a]==32) aaa[a]=0;
	strcat(bbb,"!");
	strcat(bbb,aaa);
	strcpy(author,bbb);
	aaa[0]=0;

NOFRM:	time(&now);
	fp=fopen(filename,"wb"); if (fp==NULL) exit(22);
	putc(255,fp);
	putc(MES_NORMAL,fp);
	putc(1,fp);
	fprintf(fp,"T%ld",now); putc(0,fp);
	fprintf(fp,"A%s",author); putc(0,fp);
	if (recipient[0]!=0) { fprintf(fp,"R%s",recipient); putc(0,fp); }
	fprintf(fp,"OMail"); putc(0,fp);
	fprintf(fp,"N%s",NODENAME); putc(0,fp);
	putc('M',fp);
	if (aaa[0]!=0) fprintf(fp,"%s\n",aaa);
	do {
		a=getc(stdin);
		if (a>0) putc(a,fp);
		} while(a>0);

MEFIN:	putc(0,fp);
	fclose(fp);
	return(0);

}

strucmp(st1,st2)
char st1[],st2[];
{
	int a;
	char aaa[100],bbb[100];
	for (a=0; a<=strlen(st1); ++a) aaa[a]=tolower(st1[a]);
	for (a=0; a<=strlen(st2); ++a) bbb[a]=tolower(st2[a]);
	a=strcmp(aaa,bbb);
	return(a);
}

main(argc,argv)
int argc;
char *argv[];
{
	int a,file;
	long aa;
	char aaa[100],temp[20];
	struct usersupp usersupp;
	struct smreturn smreturn;
	struct quickroom quickroom;
	struct fullroom fullroom;
	
	sprintf(temp,"/tmp/rmail.%d",getpid());
	goto TRY;
GIVEUP:	execv("/usr/bin/rmail.real",argv);
	exit(1);

TRY:	if (argc!=2) goto GIVEUP;
	strcpy(aaa,argv[1]);
	for (a=0; a<strlen(aaa); ++a) {
		if ((aaa[a]=='!')||(aaa[a]=='@')) goto GIVEUP;
		if (aaa[a]=='_') aaa[a]=32;
		}
	check4n(aaa);
	alias(aaa);
	if (strucmp(aaa,"sysop")) {
		file=open("/usr/bbs/usersupp",O_RDWR);
		if (file<0) goto GIVEUP;
		aa=finduser(file,aaa);
		if (aa==(-1L)) {
			close(file);
			goto GIVEUP;
			}
		}
	make_message(temp,aaa);
	send_message(temp,&smreturn);
	if (strucmp(aaa,"sysop")) {
		aa=finduser(file,aaa);
		read(file,&usersupp,sizeof(struct usersupp));
		for (a=0; a<(MAILSLOTS-1); ++a) {
			usersupp.mailnum[a]=usersupp.mailnum[a+1];
			usersupp.mailpos[a]=usersupp.mailpos[a+1];
			}
		usersupp.mailnum[MAILSLOTS-1]=smreturn.smnumber;
		usersupp.mailpos[MAILSLOTS-1]=smreturn.smpos;
		aa=finduser(file,aaa);
		write(file,&usersupp,sizeof(struct usersupp));
		close(file);
		}

	else {	/* file it in Aide> */
		file=open("/usr/bbs/quickroom",O_RDWR);
		lseek(file,(long)(2*sizeof(struct quickroom)),0);
		read(file,&quickroom,sizeof(struct quickroom));
		quickroom.QRhighest=smreturn.smnumber;
		lseek(file,(long)(2*sizeof(struct quickroom)),0);
		write(file,&quickroom,sizeof(struct quickroom));
		close(file);
		
		file=open("/usr/bbs/rooms/fullrm2",O_RDWR);
		read(file,&fullroom,sizeof(struct fullroom));
		for (a=0; a<(MSGSPERRM-1); ++a) {
			fullroom.FRnum[a]=fullroom.FRnum[a+1];
			fullroom.FRpos[a]=fullroom.FRpos[a+1];
			}
		fullroom.FRnum[MSGSPERRM-1]=smreturn.smnumber;
		fullroom.FRpos[MSGSPERRM-1]=smreturn.smpos;
		lseek(file,0L,0);
		write(file,&fullroom,sizeof(struct fullroom));
		close(file);
		}
	
	unlink(temp);
	exit(0);
}

alias(name)
char name[]; {
	FILE *fp;
	int a,b;
	char aaa[50],bbb[50];
	
	fp=fopen("/usr/bbs/network/mail.aliases","r");
	if (fp==NULL) return(2);
GNA:	strcpy(aaa,""); strcpy(bbb,"");
	do {
		a=getc(fp);
		if (a==',') a=0;
		if (a>0) { b=strlen(aaa); aaa[b]=a; aaa[b+1]=0; }
		} while(a>0);
	do {
		a=getc(fp);
		if (a==10) a=0;
		if (a>0) { b=strlen(bbb); bbb[b]=a; bbb[b+1]=0; }
		} while(a>0);
	if (a<0) {
		fclose(fp);
		return(1);
		}
	if (strucmp(name,aaa)) goto GNA;
	fclose(fp);
	strcpy(name,bbb);
	return(0);
}

check4n(name)
char name[]; {
	struct usersupp usersupp;
	int a,file;
	
	if ((strncmp(name,"cit",2))||(atol(&name[3])==0L)) return(0);

	file=open("/usr/bbs/usersupp",O_RDONLY);
	while (read(file,&usersupp,sizeof(struct usersupp))>0) {
		if (usersupp.eternal==atol(&name[3])) {
			strcpy(name,usersupp.fullname);
			goto CLCN;
			}
		}
CLCN:	close(file);
	return(0);
}
