#include <fcntl.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "citadel.h"

#define ILIST 5000
#define CLN (5184000L)
#define RLN (1209600L)
#define BROWSE
	/* define BROWSE if the browse system is installed. */

/* Citadel/UX sysop utilities for release 3.01
 * The software assumes that if any user who has access to this program is
 * allowed to use the sysop utilities. Make sure that the permissions
 * are correct for this.
 */

long atol;
long lseek();

long finduser(file,name)
int file;
char name[];
{
	struct usersupp temp;
	int a;
	long bottom,top,guess,obottom,otop;

	obottom=(-1L); otop=(-1L);

	bottom=0L;
	top=(lseek(file,0L,2)/(long)sizeof(struct usersupp));

FPT:	if ((obottom==bottom)&&(otop==top)) {
		return(-1L); }
	obottom=bottom; otop=top;
	guess=(((top-bottom)/2)+bottom);
	lseek(file,(guess*(long)sizeof(struct usersupp)),0);
	read(file,&temp,sizeof(struct usersupp));
	a=strucmp(temp.fullname,name);
	if (a==0)
		
		return(lseek(file,(guess*(long)sizeof(struct usersupp)),0));
	if (a<0) {
		bottom=guess;
		goto FPT; }
	if (a>0) {
		top=guess;
		goto FPT; }
	return(0);
}

cls() {
	return(system("clear"));
	}

main(argc,argv) 
int argc;
char *argv[];
{
	int a;
	char aaa[100];

	chdir(BBSDIR);

	if (!strcmp(argv[1],"-u")) {
		userpurge();
		exit(0);
		}
	if (!strcmp(argv[1],"-r")) {
		roompurge();
		exit(0);
		}
	if (!strcmp(argv[1],"-g")) {
		readregis(1);
		exit(0);
		}

MAINMENU:
	cls();
	printf("\n\n");
	printf("              *** Citadel/UX Sysop Utilities ***\n");
	printf(
	"(aide access and /etc/passwd attachments are now in useradmin)\n\n");
	printf(" 1. Purge old rooms\n");
	printf(" 2. Read registration file (user num, street, city, phone)\n");
	printf(" 3. Delete a user\n");
	printf(" 4. Unlock message file\n");
	printf(" 5. \n");
	printf(" 6. Sort the userlog\n");
	printf(" 7. Purge old users\n");
	printf(" 8. Change casing of a user's name\n");
	printf(" 9. Quit\n");
	printf(" Please enter your selection: ");
	gets(aaa);
	a=atoi(aaa);

	switch(a) {
	   case 1:	roompurge();
			break;
	   case 2:	readregis(0);
			break;
	   case 3:	deluser();
			break;
	   case 4:	unlock();
			break;
	   case 6:	sortlog("usersupp");
			break;
	   case 7:	userpurge();
			break;
	   case 8:	renameuser();
			break;
	   case 9:	exit(0);
	   default:	goto MAINMENU;
	   }
	goto MAINMENU;
	}

deluser(argc,argv)
int argc;
char *argv[]; {
int a,b,file,file2;
char dme[100];
struct usersupp usersupp;

printf("Name of user to delete? ");
gets(dme);

file=open("usersupp",O_RDONLY);
if (file<0) {
	printf("No usersupp file available.\n");
	return(1); }
file2=creat("usersupp.new",0666);
if (file<0) {
	printf("Can't open the new file.\n");
	close(file);
	return(2); }
A:	a=read(file,&usersupp,sizeof(struct usersupp));
	if (a<1) goto END;
	if (!strucmp(dme,usersupp.fullname)) goto B;
	b=write(file2,&usersupp,sizeof(struct usersupp));
	if (b<1) printf("Can't rewrite!!!\n");
	goto A;

B:	printf("%s removed\n",
		usersupp.fullname);
	goto A;

END:	close(file);
	close(file2);
	printf("                                        ");
	printf("                                   \n");
	system("mv usersupp.new usersupp");
	system("chmod 666 usersupp");
	return(0);
}
/* The msgmain file is locked through the MMstructure file during writes,
 * to avoid two processes writing in the same place. If the program crashes
 * while the file is locked, run this program to unlock it.
 */

unlock() {

	struct msgmain msgmain;
	FILE *fp;

fp=fopen("MMstructure","rb");
fread(&msgmain,sizeof(struct msgmain),1,fp);
msgmain.MMflags = msgmain.MMflags & ~MM_BUSY;
fclose(fp);
fp=fopen("MMstructure","wb");

fwrite(&msgmain,sizeof(struct msgmain),1,fp);

fclose(fp);

return(0);
}

sortlog(filename)
char *filename; {
	char aaa[100];
	struct usersupp rec1;
	struct usersupp rec2;
	int file;
	long aa,cc,dd,nrecs;

	system("clear");
	printf("6. Sort the userlog\n");
	printf("--- this will take a long time, and if it is stopped\n");
	printf("before it is finished, the userlog will be screwed up!\n");
	printf("Enter password, or <return> to abort: ");
	gets(aaa);
	if (strucmp(aaa,"ledatic")) return(1);
	sprintf(aaa,"cp %s usersupp.bak",filename);
	system(aaa);
	file=open(filename,O_RDWR);
	if (file<0) return(file);
	aa=lseek(file,0L,2); nrecs=(aa/sizeof(struct usersupp));
	for (cc=0; cc<nrecs; ++cc) {
		printf("Sorted %5d of %5d records.\n",cc,nrecs);
		for (dd=(nrecs-1L); dd>cc; --dd) {
			aa=((dd-1L)*sizeof(struct usersupp));
			lseek(file,aa,0);
			read(file,&rec1,sizeof(struct usersupp));
			read(file,&rec2,sizeof(struct usersupp));
			if (strucmp(rec1.fullname,rec2.fullname)>0) {
				lseek(file,aa,0);
				write(file,&rec2,sizeof(struct usersupp));
				write(file,&rec1,sizeof(struct usersupp));
				}
			}
		}
	close(file);
	return(0);
}

strucmp(st1,st2)
char *st1;
char *st2; {
	char aaa[100],bbb[100];
	int a;
	strcpy(aaa,st1);
	strcpy(bbb,st2);
	for (a=0; a<strlen(aaa); ++a) aaa[a]=tolower(aaa[a]);
	for (a=0; a<strlen(bbb); ++a) bbb[a]=tolower(bbb[a]);
	a=strcmp(aaa,bbb);
	return(a);
}

userpurge() {	/* removes anyone who hasn't called in 2 months */
int a,b,c,d,file,file2;
char aaa[100],bbb[100];
char dme[100];
long inlist[ILIST];
struct usersupp usersupp;
struct registration regis;
long now,call;
FILE *post;

for (a=0; a<ILIST; ++a) inlist[a]=0L;
c=0;
post=(FILE *)popen("aidepost","w");
fprintf(post,"Program: sysoputil userpurge() / Shell user = %s\n",logname());
fprintf(post,"The following users have not called in the past %ld seconds\n",
		CLN);
fprintf(post,"or have been marked for deletion, and have been purged:\n");
time(&now);
file=open("usersupp",O_RDONLY);
if (file<0) {
	printf("No usersupp file available.\n");
	return(1);
	}
file2=creat("usersupp.new",0666);
if (file<0) {
	printf("Can't open the new file.\n");
	close(file);
	return(2);
	}
	read(file,&usersupp,sizeof(struct usersupp));
	write(file2,&usersupp,sizeof(struct usersupp));
	while (read(file,&usersupp,sizeof(struct usersupp))>0) {
		call=now-(usersupp.lastcall);
		strcpy(aaa,usersupp.password);
		pwcrypt(aaa,PWCRYPT);
		if (!strucmp(aaa,"deleteme")) call=CLN+1L;
		if (usersupp.axlevel==0) call=CLN+2L;
		printf("\r%20ld ",call);
		if ((call<=CLN)||(usersupp.flags&US_PERM)) {
			b=write(file2,&usersupp,sizeof(struct usersupp));
			if (b<1) fprintf(stderr,"userpurge: cannot rewrite\n");
			inlist[c]=usersupp.eternal; ++c;
			}
		else {
			printf("%s removed\n",usersupp.fullname);
			fprintf(post,"#%-5ld %-30s\n",usersupp.eternal,
				usersupp.fullname);
			}
		}
END:	close(file);
	close(file2);
	pclose(post);
	system("mv usersupp.new usersupp");
	chmod("usersupp",0666);
	printf("Purging registration...\n");
	file=open("registration",O_RDONLY);
	file2=creat("regis.new",0666);
	while(read(file,&regis,sizeof(struct registration))>0) {
		for (a=0; a<c; ++a) if (inlist[a]==regis.RGeternal) 
			write(file2,&regis,sizeof(struct registration));
		printf("\n");
		}
	close(file);
	close(file2);
	system("mv regis.new registration");
#ifdef BROWSE
	printf("Purging browse files...\n");
	system("mkdir /tmp/browse");
	for (a=0; a<c; ++a) {
		sprintf(aaa,"subsysdir/browsedir/%ld",inlist[a]);
		sprintf(bbb,"/tmp/browse/%ld",inlist[a]);
		link(aaa,bbb);
		}
		system("rm subsysdir/browsedir/*");
		system("mv /tmp/browse/* subsysdir/browsedir");
		system("rm -r /tmp/browse");
#endif
	return(0);
}


roompurge() {	/* remove any rooms which have not been accessed in 2 weeks */
	int file,a,b;
	char fname[50];
	long act,now;
	FILE *post;
	struct stat sbuf;
	struct quickroom quickroom;

	post=(FILE *)popen("aidepost","w");
	fprintf(post,
		"Program: sysoputil roompurge() / Shell user = %s\n",logname());
	fprintf(post,
		"The following rooms have not been used for %ld seconds\n",RLN);
	fprintf(post,"and have been deleted from the room files:\n");
	time(&now);

	file=open("quickroom",O_RDWR);
	for (a=0; a<MAXROOMS; ++a) {
		sprintf(fname,"./rooms/fullrm%d",a);
		b=stat(fname,&sbuf);
		act=now-(long)sbuf.st_mtime;
		read(file,&quickroom,sizeof(struct quickroom));
		if ((a>2)&&(quickroom.QRflags&QR_INUSE)&&(act>RLN)&&(b>=0)
			&&((quickroom.QRflags&QR_NETWORK)==0)
			&&((quickroom.QRflags&QR_DIRECTORY)==0)) {

			quickroom.QRflags=quickroom.QRflags-QR_INUSE;
			lseek(file,(long)a*sizeof(struct quickroom),0);
			write(file,&quickroom,sizeof(struct quickroom));
			printf("%20s deleted\n",quickroom.QRname,act);
			fprintf(post,"%s\n",quickroom.QRname);
			}	
		}
	close(file);
	pclose(post);
	return(0);
	}


renameuser() {
	long aa;
	int file;
	struct usersupp user;
	char aaa[100];
	long finduser();

	printf("Enter old name: ");
	gets(aaa);
	file=open("usersupp",O_RDWR);
	aa=finduser(file,aaa);
	if (aa==(-1L)) {
		printf("No such user.\n");
		close(file);
		return(0); }
	read(file,&user,sizeof(struct usersupp));
	printf("Enter new name EXACTLY as it should appear: ");
	gets(user.fullname);
	if (strucmp(aaa,user.fullname)) {
		printf("You may only change casing. Rename not allowed\n");
		close(file);
		return(1);
		}

	finduser(file,aaa);
	write(file,&user,sizeof(struct usersupp));
	close(file);
	return(0);
}

readregis(mode)
int mode; {
	struct registration regis;
	int file,a,b;
	char pbuf[11];
	
	file=open("registration",O_RDONLY);
	if (file<0) {
		fprintf(stderr,"sysoputil: cannot open registration file\n");
		return(1);
		}

	if (mode==0) cls();
	while(read(file,&regis,sizeof(struct registration))>0) {
		strcpy(pbuf,regis.RGphone);
		regis.RGphone[0]=0;
		for (a=0; a<strlen(pbuf); ++a) {
			if ((pbuf[a]>='0')&&(pbuf[a]<='9')) {
				b=strlen(regis.RGphone);
				regis.RGphone[b]=pbuf[a];
				regis.RGphone[b+1]=0;
				}
			}
		while(strlen(regis.RGphone)<10) {
			strcpy(pbuf,regis.RGphone);
			strcpy(regis.RGphone," ");
			strcat(regis.RGphone,pbuf);
			}
		printf("#%4ld %-29s %14s, %-2s %6s ",
			regis.RGeternal,regis.RGname,
			regis.RGcity,regis.RGstate,regis.RGzip);
		printf("(%c%c%c) %c%c%c-%c%c%c%c\n",
			regis.RGphone[0],regis.RGphone[1],regis.RGphone[2],
			regis.RGphone[3],regis.RGphone[4],regis.RGphone[5],
			regis.RGphone[6],regis.RGphone[7],regis.RGphone[8],
			regis.RGphone[9]);
		}
	close(file);
	if (mode==0) {
		printf("<press return to continue>\n");
		gets(pbuf);
		}
	return(0);
	}

pwcrypt(text,code)
char text[];
int code; {
	int a;
	for (a=0; a<strlen(text); ++a) text[a]=(text[a]^(((code|128)^a)&0xFF));
	return(0);
	}
